#include <Array.au3>
#include <File.au3>

; size steps:
Global $a_N[] = [10, 100, 1000, 10000, 100000, 1000000]

; result array:
Global $aResults[1][UBound($a_N) + 1]
$aResults[0][0] = "N"
For $i = 1 To UBound($a_N)
	$aResults[0][$i] = $a_N[$i-1]
Next

;  ; add row for next dataset:
;  Redim $aResults[UBound($aResults) + 1][UBound($aResults, 2) ]

;  ; add dataset name:
;  $aResults[UBound($aResults) - 1][0] = "HashTableAdd"
;  ; iterate over all sample sizes
;  For $j = 0 To UBound($a_N) -1
;  	; avoid cache-effects:
;  	$oHash1 = ObjCreate("System.Collections.Hashtable")

;  	$iT = TimerInit()
;  	; include time for creation:
;  	$oHash1 = ObjCreate("System.Collections.Hashtable")
;  	For $i = 1 To $a_N[$j]
;  		$oHash1.add($i, "Teststring")
;  	Next
;  	$aResults[UBound($aResults) - 1][$j + 1] = TimerDiff($iT)
;  Next


;  Redim $aResults[UBound($aResults) + 1][UBound($aResults, 2)]
;  $aResults[UBound($aResults) - 1][0] = "HashTableIs"
;  For $j = 0 To UBound($a_N) -1
;  	; avoid cache-effects:
;  	$oHash2 = ObjCreate("System.Collections.Hashtable")

;  	$iT = TimerInit()
;  	$oHash2 = ObjCreate("System.Collections.Hashtable")
;  	For $i = 1 To $a_N[$j]
;  		$oHash2($i) = "Teststring"
;  	Next
;  	$aResults[UBound($aResults) - 1][$j + 1] = TimerDiff($iT)
Next


Redim $aResults[UBound($aResults) + 1][UBound($aResults, 2)]
$aResults[UBound($aResults) - 1][0] = "DicAdd"
For $j = 0 To UBound($a_N) -1
	; avoid cache-effects:
	Global $oDic1 = ObjCreate("Scripting.Dictionary")

	$iT = TimerInit()
	Global $oDic1 = ObjCreate("Scripting.Dictionary")
	For $i = 1 To $a_N[$j]
		$oDic1.add($i, "Teststring")
	Next
	$aResults[UBound($aResults) - 1][$j + 1] = TimerDiff($iT)
Next


Redim $aResults[UBound($aResults) + 1][UBound($aResults, 2)]
$aResults[UBound($aResults) - 1][0] = "DicIs"
For $j = 0 To UBound($a_N) -1
	; avoid cache-effects:
	Global $oDic2 = ObjCreate("Scripting.Dictionary")

	$iT = TimerInit()
	Global $oDic2 = ObjCreate("Scripting.Dictionary")
	For $i = 1 To $a_N[$j]
		$oDic2($i) = "Teststring"
	Next
	$aResults[UBound($aResults) - 1][$j + 1] = TimerDiff($iT)
Next


Redim $aResults[UBound($aResults) + 1][UBound($aResults, 2)]
$aResults[UBound($aResults) - 1][0] = "MapInt"
For $j = 0 To UBound($a_N) -1


	$iT = TimerInit()
	Global $mMap1[]
	For $i = 1 To $a_N[$j]
		$mMap1[$i] = "Teststring"
	Next
	$aResults[UBound($aResults) - 1][$j + 1] = TimerDiff($iT)
Next

Redim $aResults[UBound($aResults) + 1][UBound($aResults, 2)]
$aResults[UBound($aResults) - 1][0] = "MapString"
For $j = 0 To UBound($a_N) -1
	$iT = TimerInit()
	Global $mMap2[]
	For $i = 1 To $a_N[$j]
		$mMap2[String($i)] = "Teststring"
	Next
	$aResults[UBound($aResults) - 1][$j + 1] = TimerDiff($iT)
Next


Redim $aResults[UBound($aResults) + 1][UBound($aResults, 2)]
$aResults[UBound($aResults) - 1][0] = "MapAppend"
For $j = 0 To UBound($a_N) -1
	$iT = TimerInit()
	Global $mMap3[]
	For $i = 1 To $a_N[$j]
		MapAppend($mMap3, "Teststring")
	Next
	$aResults[UBound($aResults) - 1][$j + 1] = TimerDiff($iT)
Next


Redim $aResults[UBound($aResults) + 1][UBound($aResults, 2)]
$aResults[UBound($aResults) - 1][0] = "StringSplit"
For $j = 0 To UBound($a_N) -1
	$iT = TimerInit()
	Global $s_String = ""
	For $i = 1 To $a_N[$j]
		$s_String &= "Teststring" & ";"
	Next
	$a_Array = StringSplit(StringTrimRight($s_String, ";"), ";", 3)
	$aResults[UBound($aResults) - 1][$j + 1] = TimerDiff($iT)
Next


Redim $aResults[UBound($aResults) + 1][UBound($aResults, 2)]
$aResults[UBound($aResults) - 1][0] = "ArrayList"
For $j = 0 To UBound($a_N) -1
	$iT = TimerInit()
	Global $a_Array[1]
	For $i = 0 To $a_N[$j] -1
		If $i = UBound($a_Array) Then Redim $a_Array[$i * 2]
		$a_Array[$i] = "Teststring"
	Next
	Redim $a_Array[$i]
	$aResults[UBound($aResults) - 1][$j + 1] = TimerDiff($iT)
Next



Redim $aResults[UBound($aResults) + 1][UBound($aResults, 2)]
$aResults[UBound($aResults) - 1][0] = "ArrayFixedSize"
For $j = 0 To UBound($a_N) -1
	$iT = TimerInit()
	Global $a_Array[$a_N[$j]]
	For $i = 0 To $a_N[$j] -1
		$a_Array[$i] = "Teststring"
	Next
	$aResults[UBound($aResults) - 1][$j + 1] = TimerDiff($iT)
Next



_ArrayDisplay($aResults, "Results for adding N values to structure", "1:", 64, Default, "method|" & _ArrayToString($a_N))

_ArrayTranspose($aResults)
_FileWriteFromArray("Add.csv", $aResults, 0, Default, ";")
