#include <Array.au3>
#include <File.au3>

Global $x

; size steps:
Global $aN[] = [10, 100, 1000, 10000, 100000, 1000000]

; result array:
Global $aResults[1][UBound($aN) + 1]
$aResults[0][0] = "N"
For $i = 1 To UBound($aN)
	$aResults[0][$i] = $aN[$i-1]
Next



; dictionary: element access with key as parameter
Redim $aResults[UBound($aResults) + 1][UBound($aResults, 2)]
$aResults[UBound($aResults) - 1][0] = "DictionaryKeyAsParameter" ;associative
For $j = 0 To UBound($aN) -1
	Global $oDic1 = ObjCreate("Scripting.Dictionary")
	For $i = 1 To $aN[$j]
		$oDic1($i) = "Teststring"
	Next

	$iT = TimerInit()
	For $i = 1 To $aN[$j]
		$x = $oDic1($i)
	Next
	$aResults[UBound($aResults) - 1][$j + 1] = TimerDiff($iT)
Next


; dictionary: access via item-method
Redim $aResults[UBound($aResults) + 1][UBound($aResults, 2)]
$aResults[UBound($aResults) - 1][0] = "DictionaryItem"  ; associative
For $j = 0 To UBound($aN) -1
	Global $oDic1 = ObjCreate("Scripting.Dictionary")
	For $i = 1 To $aN[$j]
		$oDic1($i) = "Teststring"
	Next

	$iT = TimerInit()
	For $i = 1 To $aN[$j]
		$x = $oDic1.Item($i)
	Next
	$aResults[UBound($aResults) - 1][$j + 1] = TimerDiff($iT)
Next

; dictionary: all items as an array (no sort order!)
Redim $aResults[UBound($aResults) + 1][UBound($aResults, 2)]
$aResults[UBound($aResults) - 1][0] = "DictionaryItems" ; sequential
For $j = 0 To UBound($aN) -1
	Global $oDic1 = ObjCreate("Scripting.Dictionary")
	For $i = 1 To $aN[$j]
		$oDic1($i) = "Teststring"
	Next

	$iT = TimerInit()
	For $i In $oDic1.Items()
		$x = $i
	Next
	$aResults[UBound($aResults) - 1][$j + 1] = TimerDiff($iT)
Next



; map: For in
Redim $aResults[UBound($aResults) + 1][UBound($aResults, 2)]
$aResults[UBound($aResults) - 1][0] = "MapForIn"  ; sequential
; iterate over all sample sizes
For $j = 0 To UBound($aN) -1
	; create the structure (not part of measurement)
	Global $mMap2[]
	For $i = 1 To $aN[$j]
		MapAppend($mMap2, "TestString")
		$mMap2[$i] = "Teststring"
	Next

	; the actual measurement
	$iT = TimerInit()
	For $i In $mMap2
		$x = $i
	Next
	$aResults[UBound($aResults) - 1][$j + 1] = TimerDiff($iT)
Next


; map: element access with integer index
Redim $aResults[UBound($aResults) + 1][UBound($aResults, 2)]
$aResults[UBound($aResults) - 1][0] = "MapIntIndex"  ; associative and sequential
For $j = 0 To UBound($aN) -1
	Global $mMap1[]
	For $i = 1 To $aN[$j]
		MapAppend($mMap1, "TestString")
		$mMap1[$i] = "Teststring"
	Next

	$iT = TimerInit()
	For $i = 1 To $aN[$j]
		$x = $mMap1[$i]
	Next
	$aResults[UBound($aResults) - 1][$j + 1] = TimerDiff($iT)
Next


; map: element access via key
Redim $aResults[UBound($aResults) + 1][UBound($aResults, 2)]
$aResults[UBound($aResults) - 1][0] = "MapStringKey" ; associative
For $j = 0 To UBound($aN) -1
	Global $mMap2[]
	For $i = 1 To $aN[$j]
		$mMap2[String($i)] = "Teststring"
	Next

	$iT = TimerInit()
	For $i = 1 To $aN[$j]
		$x = $mMap2[String($i)]
	Next
	$aResults[UBound($aResults) - 1][$j + 1] = TimerDiff($iT)
Next


; array: integer index
Redim $aResults[UBound($aResults) + 1][UBound($aResults, 2)]
$aResults[UBound($aResults) - 1][0] = "ArrayIndex" ; sequential
For $j = 0 To UBound($aN) -1
	Global $aArray[$aN[$j]]
	For $i = 0 To $aN[$j] -1
		$aArray[$i] = "Teststring"
	Next

	$iT = TimerInit()
	For $i = 0 To $aN[$j] - 1
		$x = $aArray[$i]
	Next
	$aResults[UBound($aResults) - 1][$j + 1] = TimerDiff($iT)
Next


; array: integer index
Redim $aResults[UBound($aResults) + 1][UBound($aResults, 2)]
$aResults[UBound($aResults) - 1][0] = "ArrayForIn" ; sequential
For $j = 0 To UBound($aN) -1
	Global $aArray[$aN[$j]]
	For $i = 0 To $aN[$j] -1
		$aArray[$i] = "Teststring"
	Next

	$iT = TimerInit()
	For $i In $aArray
		$x = $i
	Next
	$aResults[UBound($aResults) - 1][$j + 1] = TimerDiff($iT)
Next


; hash-table: element access via key
Redim $aResults[UBound($aResults) + 1][UBound($aResults, 2)]
$aResults[UBound($aResults) - 1][0] = "HashTable"   ; associative
For $j = 0 To UBound($aN) -1
	$oHash2 = ObjCreate("System.Collections.Hashtable")
	For $i = 1 To $aN[$j]
		$oHash2(String($i)) = "Teststring"
	Next

	$iT = TimerInit()
	For $i = 1 To $aN[$j]
		$x = $oHash2(String($i))
	Next
	$aResults[UBound($aResults) - 1][$j + 1] = TimerDiff($iT)
Next


; 2D-Array Binary-Search
Redim $aResults[UBound($aResults) + 1][UBound($aResults, 2)]
$aResults[UBound($aResults) - 1][0] = "2DArrayBinSearch"   ; associative
For $j = 0 To UBound($aN) -1
	; build 2D ([[Key,Value], [Key,Value], ..]) Array
	Global $aArray[$aN[$j]][2]
	For $i = 0 To $aN[$j] -1
		$aArray[$i][0] = String($i)
		$aArray[$i][1] = "Teststring" & $i
	Next

	; a binary search algorithm for this 2D-Key-Value-Array
	$iT = TimerInit()
	Local $m, $vM
	For $i = 0 To $aN[$j] - 1

		Local $l = 0, $r = $aN[$j]
		Do
			$m = Int(($l + $r) / 2)
			$vM = $aArray[$m][0]
			If $vM = $i Then ; found
				$x = $aArray[$m][1]
				ExitLoop
			ElseIf $vM > $i Then
				$r = $m - 1
			Else
				$l = $m + 1
			EndIf
		Until $l > $r
		; no match found (not implemented here)
	Next
	$aResults[UBound($aResults) - 1][$j + 1] = TimerDiff($iT)
Next


; 2D-Array interpolation-Search (best-case here) - not a very practical scenario but also interesting
Redim $aResults[UBound($aResults) + 1][UBound($aResults, 2)]
$aResults[UBound($aResults) - 1][0] = "2DArrayInterpolationSearch"   ; associative
For $j = 0 To UBound($aN) -1
	; build 2D ([[Key,Value], [Key,Value], ..]) Array
	Global $aArray[$aN[$j]][2]
	Local $t = -1
	For $i = 0 To $aN[$j] -1
		$t += Random(1, 100, 1)	; random to avoid to create a best-case scenario (entries from 0 to N with Step 1)
		$aArray[$i][0] = $t
		$aArray[$i][1] = "Teststring" & $t
	Next

	; a interpolation search algorithm for this 2D-Key-Value-Array
	$iT = TimerInit()
	Local $dx, $dy, $m, $b, $S
	For $i = 0 To $aN[$j] - 1
		Local $l = 0, $r = $aN[$j] - 1
		$S = $aArray[$i][0]
		Do
			$dx = $r - $l
			If $dx = 1 Then
				If $aArray[$r][0] = $S Then
					$x = $aArray[$r][1]
				ElseIf $aArray[$l][0] = $S Then
					$x = $aArray[$l][1]
				EndIf
				ExitLoop ;no implementation of no match here
			EndIf

			If $dx = 0 Then ExitLoop

			$dy = $aArray[$r][0] - $aArray[$l][0]

			If $dy = 0 Then
				If $aArray[$l][0] = $S Then $x = $aArray[$l][1]
				ExitLoop ; no implementation of no match here
			EndIf

			$m = $dy / $dx
			$b = Int(($S - $aArray[$l][0]) / $m)
			$p = $l + $b
			If $aArray[$p][0] = $S Then ; found
				$x = $aArray[$p][1]
				ExitLoop
			ElseIf  $aArray[$p][0] > $S Then
				$r = $p - 1
			Else
				$l = $p + 1
			EndIf
		Until $l > $r
		; no match found (not implemented here)
	Next
	$aResults[UBound($aResults) - 1][$j + 1] = TimerDiff($iT)
Next


_ArrayDisplay($aResults, "Results for reading N values from a structure", "1:", 64, Default, "method|" & _ArrayToString($aN))

_ArrayTranspose($aResults)
_FileWriteFromArray("Read.csv", $aResults, 0, Default, ";")

